datablock ItemData(umbrellaHatItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./umbrella.dts";
	rotate = false;
	mass = 1;
	drag = 2;

	density = 0.2;
	elasticity = 0.2;
	friction = 1;
	gravityMod = 0.5;
	emap = true;

	uiName = "Umbrella Hat";
	iconName = "./icon_umbrella";
	doColorShift = true;
	colorShiftColor = "0.8 0.2 0.2 1";

	image = umbrellaHatImage;
	canDrop = true;
};
datablock ShapeBaseImageData(umbrellaHatImage)
{
	shapeFile = "./umbrella.dts";
	emap = true;

	mountPoint = 0;
	offset = "-0.08 0.255 0";
	eyeOffset = "0.6 1.2 -0.4";
	eyeRotation = "0 -1 0 90";
	rotation = "0 -1 0 90";

	className = "WeaponImage";
	item = umbrellaHatItem;
	armReady = true;

	doColorShift = true;
	colorShiftColor = umbrellaHatItem.colorShiftColor;
	stateName[0]						= "Activate";
	stateTimeoutValue[0]				= 0.1;
	stateTransitionOnTimeout[0]			= "Check";
	
	stateName[1]						= "Check";
	stateTransitionOnTriggerUp[1]		= "Ready";
	
	stateName[2]						= "Ready";
	stateTransitionOnTriggerDown[2]		= "Equip";
	
	stateName[3]						= "Equip";
	stateScript[3]						= "onEquip";
	stateTimeoutValue[3]				= 0.1;
	stateTransitionOnTimeout[3]			= "Check";
};
function umbrellaHatImage::onMount(%this,%pl,%slot)
{
	if(%pl.getMountedImage(2) == umbrellaHatHeadImage.getId())
	{
		%pl.mountImage(umbrellaHatEImage,0);
		return;
	}
	%pl.playThread(1,armReadyRight);
	if(isObject(%cl = %pl.client))
	{
		if(%cl.umbrellaHatTutorial)
		return;
		%cl.umbrellaHatTutorial = 1;
		messageClient(%cl,'',"<font:Arial:24>\c3Umbrella Hat");
		messageClient(%cl,'',"\c3Left clicking equips the umbrella hat.");
		messageClient(%cl,'',"\c3Once the umbrella hat is equipped hold the jump key to jump higher and fall slower");
	}
}
function umbrellaHatImage::onEquip(%this,%pl,%slot)
{
	%pl.mountImage(umbrellaHatHeadImage,2);
	%pl.mountImage(umbrellaHatEImage,0);
}
datablock ShapeBaseImageData(umbrellaHatEImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = true;

	mountPoint = 0;
	offset = "-0.08 0.255 0";
	eyeOffset = 0;
	rotation = "0 -1 0 90";

	className = "WeaponImage";
	item = umbrellaHatItem;
	armReady = false;

	doColorShift = true;
	colorShiftColor = umbrellaHatItem.colorShiftColor;
	stateName[0]						= "Activate";
	stateTimeoutValue[0]				= 0.1;
	stateTransitionOnTimeout[0]			= "Check";
	
	stateName[1]						= "Check";
	stateTransitionOnTriggerUp[1]		= "Ready";
	
	stateName[2]						= "Ready";
	stateTransitionOnTriggerDown[2]		= "Equip";
	
	stateName[3]						= "Equip";
	stateScript[3]						= "onEquip";
	stateTimeoutValue[3]				= 0.1;
	stateTransitionOnTimeout[3]			= "Check";
};
function umbrellaHatEImage::onMount(%this,%pl,%slot)
{
	%pl.playThread(1,root);
}
function umbrellaHatEImage::onEquip(%this,%pl,%slot)
{
	if(%pl.getMountedImage(2) == umbrellaHatHeadImage.getId())
	%pl.unMountImage(2);
	
	%pl.mountImage(umbrellaHatImage,0);
}
datablock ShapeBaseImageData(umbrellaHatHeadImage)
{
	shapeFile = "./umbrella.dts";
	emap = false;

	mountPoint = $HeadSlot;
	offset = "0 0 0.17";
	eyeOffset = "0 0 0.17";
	doColorShift = true;
	colorShiftColor = umbrellaHatItem.colorShiftColor;
};
package swol_umbrellaHat
{
	function umbrellaHatHeadImage::onMount(%this,%pl,%slot)
	{
		%pl.extremeStyle = true;
		if(%pl.pressingSpacebar)
		{
			if(!%pl.umbrellaGliding)
			%pl.umbrellaGlideStart();
		}
	}
	function umbrellaHatHeadImage::onUnMount(%this,%pl,%slot)
	{
		%pl.extremeStyle = false;
		if(%pl.umbrellaGliding)
		%pl.umbrellaGlideStop();
	}
	function armor::onTrigger(%this,%pl,%slot,%state)
	{
		if(%slot == 2)
		{
			if(%pl.extremeStyle)
			{
				if(%state)
				{
					%pl.pressingSpacebar = 1;
					if(!%pl.umbrellaGliding)
					%pl.umbrellaGlideStart();
				}
				else
				{
					%pl.pressingSpacebar = 0;
					if(%pl.umbrellaGliding)
					%pl.umbrellaGlideStop();
				}
			}
		}
		parent::onTrigger(%this,%pl,%slot,%state);
	}
	function player::umbrellaGlideStart(%this)
	{
		%z = new physicalZone()
		{
			velocityMod = 1;
			gravityMod = 0.5;
			extraDrag = 0;
			isWater = 0;
			polyhedron = "0 0 0 1 0 0 0 -1 0 0 0 1";
			scale = "2 2 2";
		};
		%this.umbrellaGliding = true;
		%z.position = vectorAdd(%this.getPosition(),-1 SPC 1 SPC -1);
		%this.umbrellaGlideZone = %z;
		%this.umbrellaGlideLoop();
	}
	function player::umbrellaGlideLoop(%this)
	{
		cancel(%this.umbrellaGlideSched);
		%this.umbrellaGlideZone.setTransform(vectorAdd(%this.getPosition(),-1 SPC 1 SPC -1));
		%pass = false;
		for(%i=0;%i<%this.getDatablock().maxTools;%i++)
		{
			%item = %this.tool[%i];

			if(%item == umbrellaHatItem.getId())
			{
				%pass = true;
				break;
			}
		}
		if(!%pass)
		{
			%this.umbrellaGlideStop();
			if(%this.getMountedImage(2) == umbrellaHatHeadImage.getId())
			%this.unMountImage(2);
			return;
		}
		%this.umbrellaGlideSched = %this.schedule(50,umbrellaGlideLoop);
	}
	function player::umbrellaGlideStop(%this)
	{
		cancel(%this.umbrellaGlideSched);
		%this.umbrellaGlideZone.delete();
		%this.umbrellaGliding = false;
	}
};
activatePackage(swol_umbrellaHat);